controllers/UserController.php
<?php

namespace app\controllers;

use Yii;
use app\models\User;
use app\models\SearchUser;
use yii\filters\AccessControl;
use app\models\form\ChangePassWordForm;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * UserController implements the CRUD actions for User model.
 */
class UserController extends Controller {

	/**
	 * {@inheritdoc}
	 */
	public function behaviors() {
		return [
			'access' => [
				'class' => AccessControl::className(),
				'only'  => [
					'index',
					'create',
					'update',
					'delete',
					'update-user',
				],
				'rules' => [
					[
						'actions'       => [
							'index',
							'create',
							'update',
							'delete',
							'update-user',
						],
						'allow'         => true,
						'roles'         => ['@'],
						'matchCallback' => function($rule, $action) {
							return Yii::$app->user->identity->role == User::ADMIN || $this->action->id == 'update-user';
						},
					],
				],
			],
			'verbs'  => [
				'class'   => VerbFilter::className(),
				'actions' => [
					'delete' => ['POST'],
				],
			],
		];
	}

	/**
	 * Lists all User models.
	 * @return mixed
	 */
	public function actionIndex() {
		$searchModel  = new SearchUser();
		$dataProvider = $searchModel->search(Yii::$app->request->queryParams);
		return $this->render('index', [
			'searchModel'  => $searchModel,
			'dataProvider' => $dataProvider,
		]);
	}

	/**
	 * Displays a single User model.
	 *
	 * @param integer $id
	 *
	 * @return mixed
	 * @throws NotFoundHttpException if the model cannot be found
	 */
	public function actionView($id) {
		return $this->render('view', [
			'model' => $this->findModel($id),
		]);
	}

	/**
	 * Creates a new User model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 * @return mixed
	 */
	public function actionCreate() {
		$model = new User();
		if ($model->load(Yii::$app->request->post())) {
			$model->password = Yii::$app->getSecurity()->generatePasswordHash($model->password);
			if ($model->save()) {
				return $this->redirect([
					'view',
					'id' => $model->id,
				]);
			}
		}
		return $this->render('create', [
			'model' => $model,
		]);
	}

	/**
	 * Updates an existing User model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 *
	 * @param integer $id
	 *
	 * @return mixed
	 * @throws NotFoundHttpException if the model cannot be found
	 */
	public function actionUpdate($id) {
		$model = $this->findModel($id);
		if ($model->load(Yii::$app->request->post())) {
			$model->password = Yii::$app->getSecurity()->generatePasswordHash($model->password);
			if ($model->save()) {
				return $this->redirect([
					'view',
					'id' => $model->id,
				]);
			}
		}
		return $this->render('update', [
			'model' => $model,
		]);
	}

	public function actionUpdateUser() {

		$model = new ChangePasswordForm();
		if ($model->load(Yii::$app->request->post()) && $model->changePassword()) {
			Yii::$app->session->setFlash('success', "Change password success");
		}
		$user            = User::findOne(Yii::$app->user->identity->id);
		$model->username = $user->username;
		return $this->render('change-password', ['model' => $model]);
	}

	/**
	 * Deletes an existing User model.
	 * If deletion is successful, the browser will be redirected to the 'index' page.
	 *
	 * @param integer $id
	 *
	 * @return mixed
	 * @throws NotFoundHttpException if the model cannot be found
	 */
	public function actionDelete($id) {
		$this->findModel($id)->delete();
		return $this->redirect(['index']);
	}

	/**
	 * Finds the User model based on its primary key value.
	 * If the model is not found, a 404 HTTP exception will be thrown.
	 *
	 * @param integer $id
	 *
	 * @return User the loaded model
	 * @throws NotFoundHttpException if the model cannot be found
	 */
	protected function findModel($id) {
		if (($model = User::findOne($id)) !== null) {
			return $model;
		}
		throw new NotFoundHttpException('The requested page does not exist.');
	}
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\widgets\Alert;
use yii\helpers\Html;
use yii\bootstrap\Nav;
use yii\bootstrap\NavBar;
use yii\widgets\Breadcrumbs;
use app\assets\AppAsset;
use app\models\User;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body>
<?php $this->beginBody() ?>

<div class="wrap">
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' =>  yii\helpers\Url::toRoute('request/index'),
        'options' => [
            'class' => 'navbar-inverse navbar-fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav navbar-right'],
        'items' => [
            ['label' => 'Profile', 'url' => ['/user/update-user']],
            ['label' => 'User', 'url' => ['/user'],  'visible' => !(Yii::$app->user->isGuest ? true : Yii::$app->user->identity->role == User::USER)],
            ['label' => 'User', 'url' => ['/user'], 'visible' =>  !(Yii::$app->user->isGuest ? true : Yii::$app->user->identity->role == User::USER)],
            ['label' => 'Employee', 'url' => ['/employee'], 'visible' => !(Yii::$app->user->isGuest ? true : Yii::$app->user->identity->role == User::USER)],
            ['label' => 'Location', 'url' => ['/location'], 'visible' => !(Yii::$app->user->isGuest ? true : Yii::$app->user->identity->role == User::USER)],
            ['label' => 'Transfer', 'url' => ['/transfer'], 'visible' => !(Yii::$app->user->isGuest ? true : Yii::$app->user->identity->role == User::USER)],
            ['label' => 'Project', 'url' => ['/project'], 'visible' => !(Yii::$app->user->isGuest ? true : Yii::$app->user->identity->role == User::USER)],
            ['label' => 'Request', 'url' => ['/request']],
            Yii::$app->user->isGuest ? (
                ['label' => 'Login', 'url' => ['/site/login']]
            ) : (
                '<li>'
                . Html::beginForm(['/site/logout'], 'post')
                . Html::submitButton(
                    'Logout (' . Yii::$app->user->identity->username . ')',
                    ['class' => 'btn btn-link logout']
                )
                . Html::endForm()
                . '</li>'
            )
        ],
    ]);
    NavBar::end();
    ?>

    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</div>

<footer class="footer">
    <div class="container">
        <p class="pull-left">&copy; My Company <?= date('Y') ?></p>

        <p class="pull-right"><?= Yii::powered() ?></p>
    </div>
</footer>
<?php
if (!Yii::$app->user->isGuest && Yii::$app->user->identity->role == \app\models\User::ADMIN) {
	$this->registerJs(<<<JS
	var conn = new WebSocket('ws://localhost:8000');
	conn.onopen = function(e) {
		console.log("Connection established!");
	};

	conn.onmessage = function(e) {
		console.log('success');
		// alert('An Employee created a request!');
		alert(e.data);
	};
JS
	);
}
?>
<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>